from cryptography.hazmat.primitives.asymmetric import rsa, padding
from cryptography.hazmat.primitives import hashes

private_key = rsa.generate_private_key(public_exponent=65537, key_size=2048)
public_key = private_key.public_key()

plaintext_in = "The quick brown fox jumps over the lazy dog"


def encrypt(plaintext, public_key):
    return public_key.encrypt(
        plaintext,
        padding.OAEP(
            mgf=padding.MGF1(algorithm=hashes.SHA256()),
            algorithm=hashes.SHA256(),
            label=None,
        ),
    )


ciphertext = encrypt(bytes(plaintext_in, "utf-8"), public_key)


def decrypt(ciphertext, private_key):
    return private_key.decrypt(
        ciphertext,
        padding.OAEP(
            mgf=padding.MGF1(algorithm=hashes.SHA256()),
            algorithm=hashes.SHA256(),
            label=None,
        ),
    )


bytes_out = decrypt(ciphertext, private_key)
plaintext_out = bytes_out.decode("utf-8")

assert plaintext_in == plaintext_out  # should be equal
